<template>
  <div class="account-controls">
    <div v-if="order.type === STEP.BOOKING">
      <ob-button
          v-if="order.status === STEP.ACTIVE"
          @click="acceptOrderWrapper"
          label="Согласиться"
          :disabled="isSended"
      />
      <div v-if="order.status === STEP.ACCEPTED" class="account-controls__await">
        Ожидаем ответа от заказчика до {{transformTime(order.completionDt)}}
      </div>
      <ob-button
          v-if="order.status === STEP.WINNER && order.orderStatus === STEP.ALLOCATED"
          @click="requestExecution"
          label="Отправить"
          :disabled="!canSubmitDoc"
      />
    </div>
    <div v-if="order.type === STEP.AUCTION">
      <template v-if="order.status !== STEP.WINNER">
        <div class="account-controls__step-block">
          <div
              class="account-controls__step-block-item"
              :class="{'disabled': price - order.biddingStep - 1 < 0}"
              @click="onMinus"
          >
            <i class="icon minus"/>
          </div>
          <div class="account-controls__step-block-item account-controls__step-block-item_value">
            {{ price | currency }}
          </div>
          <div
              class="account-controls__step-block-item"
              :class="{'disabled': price + order.biddingStep > order.tariffLimit}"
              @click="onPlus"
          >
            <i class="icon plus"/>
          </div>
        </div>
        <ob-button
            @click="makeBidWrapper"
            :disabled="price >= order.totalPriceAmount.priceWithVat"
            :label="order.currentState === STEP.NO_BIDS ? 'Сделать ставку' : 'Обновить ставку'"
        />
      </template>
      <div
          v-if="order.status === STEP.WINNER && order.orderStatus === STEP.NEW"
          class="account-controls__await"
      >
        Ваша ставка выиграла. Ожидаем решения до {{transformTime(order.completionDt)}}
      </div>


      <ob-button
          v-if="order.status === STEP.COMPLETED && order.orderStatus === STEP.ALLOCATED"
          @click="requestExecution"
          label="Отправить"
          :disabled="!canSubmitDoc"
      />
    </div>
  </div>
</template>
<script>
import ObButton from 'common-components/src/obComponents/obButton'
import { mapActions, mapGetters } from 'vuex'
import STEPS from '@/constants/steps.js'
import moment from 'moment'
import accountTimerMixin from "@/mixins/account-timer-mixin"

export default {
  components: { ObButton },
  mixins: [
    accountTimerMixin
  ],
  data () {
    return {
      price: 0,
      STEP: STEPS,
      isSended: false,
    }
  },
  mounted() {
    this.price = this.order.totalPrice
    this.countDownTimer(this.order.expirationStatusDate)
  },
  computed: {
    ...mapGetters({
      order: 'account/order',
      canAcceptResource: 'account/canAcceptResource',
      canSubmitDoc:  'account/canSubmitDoc',
    })
  },
  methods: {
    transformTime(time) {
      return moment(time).format('HH:mm DD.MM.YYYY')
    },
    ...mapActions({
      acceptOrder: 'account/acceptOrder',
      makeBid: 'account/makeBid',
      acceptResource: 'account/acceptResource',
      requestExecution: 'account/requestExecution'
    }),
    acceptOrderWrapper() {
      this.$eventGlobal.$emit('account-order-accept-booking')
      this.isSended = true
      this.acceptOrder({uuid: this.order.uuid})
    },
    makeBidWrapper() {
      this.makeBid({bid: this.price, lotUuid: this.order.uuid});
    },
    onMinus() {
      this.price -= this.order.biddingStep;
    }, 
    onPlus() {
      this.price += this.order.biddingStep;
    }
  },
  watch: {
    'order.totalPrice'() {
      this.price = this.order.totalPrice
    },
    order () {
      this.isSended = false
    },
  }
}
</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
.account-controls {
  display: flex;
  justify-content: center;
  width: 100%;
  &__await {
    margin-bottom: 25px;
    line-height: 18px;
    text-align: center;
    letter-spacing: 0.2px;
  }
  &__step-block {
    display: flex;
    justify-content: space-between;
    margin-bottom: 20px;
    &-item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      font-size: 40px;
      color:$color-blue-navy-blue;
      &.disabled {
        pointer-events: none;
        color: $gray-window;
      }
      &_value {
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $color-text-base;
        margin: 10px 0px;
      }
    }
  }
}
</style>